package com.mist;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import com.mist.types.TypeCall;
import com.mist.types.TypeSMS;
/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Ingenieria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunay
 * 
 * @Author UOC
 * @version Android 1.6, 2.1, 2.2
 */
public class Main extends Activity {
	
	static final int INSTRUCCIONES_DIALOG_ID = 0;
	static final int INFO_DIALOG_ID = 1;
	
	static final String TAG = "TAPJACKING";
	
	static final int VELOCITY_LOW = 1;
	static final int VELOCITY_FAST = 0;
	
	static final int OPACITY_TOTAL = 0;
	static final int OPACITY_MIDDLE = 1;
	static final int OPACITY_NONE = 2;
	
	static final int TYPE_SMS = 0;
	static final int TYPE_CALL = 1;
	
	//Mtode inicial que carrega l'aplicaci
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		TextView version = (TextView)findViewById(R.id.version);
		version.setText("Versin Android: "+android.os.Build.VERSION.RELEASE+" AndroidCode: "+android.os.Build.VERSION.SDK_INT);
			
	}
	
	
	//Iniciem el Service
	public void start(View v) {
		Log.d(TAG, "Prefs "+Prefs.getVelocity(this));
		Log.d(TAG, "Prefs "+Prefs.getOpacity(this));
		Log.d(TAG, "Prefs "+Prefs.getType(this));
		
		//Carreguem el test segons la opci seleccionada
		if(Integer.parseInt(Prefs.getType(this)) == TYPE_SMS){
			TapjackingService.setLoad(new TypeSMS(Integer.parseInt(Prefs.getVelocity(this))));
		}else{
			TapjackingService.setLoad(new TypeCall(Integer.parseInt(Prefs.getVelocity(this))));
		}
		//Iniciem el servei
		startService(new Intent(TapjackingService.class.getName()));
		
	}
	
	public void mostrarDialog(View v){
		showDialog(INSTRUCCIONES_DIALOG_ID);
	}
	
	/**
	 * Funci que construeix els components dialeg.
	 */
	@Override
    protected Dialog onCreateDialog(int id) {
		AlertDialog.Builder builder;
    	AlertDialog alertDialog;
    	Context mContext = getApplicationContext();
    	
    	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(LAYOUT_INFLATER_SERVICE);
    	
    	switch (id) {
        case INSTRUCCIONES_DIALOG_ID:
        	View layout = inflater.inflate(R.layout.custom_dialog,
        	                               (ViewGroup) findViewById(R.id.layout_root));

        	TextView body = (TextView) layout.findViewById(R.id.text);
        	body.setText(R.string.inst_text);
        	ImageView image = (ImageView) layout.findViewById(R.id.image);
        	image.setImageResource(R.drawable.android);

        	builder = new AlertDialog.Builder(this);
        	builder.setView(layout);
        	alertDialog = builder.create();
        	alertDialog.setTitle(R.string.inst_title);
        	return alertDialog;
        case INFO_DIALOG_ID:
        	View layout_info = inflater.inflate(R.layout.info,
        	                               (ViewGroup) findViewById(R.id.layout_info));

        	TextView infoText = (TextView) layout_info.findViewById(R.id.info_text);
        	infoText.setText(R.string.info_text);
        	TextView infoText2 = (TextView) layout_info.findViewById(R.id.info_text2);
        	infoText2.setText(R.string.info_text2);
        	        	
        	builder = new AlertDialog.Builder(this);
        	builder.setView(layout_info);
        	alertDialog = builder.create();
        	alertDialog.setTitle(R.string.info_title);
        	return alertDialog;
        
        default:
        	return null;
        }
	}
	
	//Genera el men
	@Override
	public boolean onCreateOptionsMenu(Menu menu){
		super.onCreateOptionsMenu(menu);
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}
	
	/**
	 * Funci que captura l'item seleccionat del menu 
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item){
		switch(item.getItemId()){
		case R.id.more:
			showDialog(INFO_DIALOG_ID);
			return true;
		case R.id.settings:
			startActivity(new Intent(this, Prefs.class));
			return true;
		}
		return false;
	}
	
	/*
	 * Finalizamos la app
	 * @param v
	 */
	public void end(View v){
		super.finish();
	}
	
	public Activity getActivity(){
		return this;
	}
	
	
	
}
