package com.mist;

import android.content.Context;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Ingenieria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunay
 * 
 * @Author UOC
 * @version Android 1.6, 2.1, 2.2
 */
public class Prefs extends PreferenceActivity {
	
	private static final String KEY_VEL			= "velocidad";
	private static final String KEY_OPA 		= "opacidad";
	private static final String KEY_TYPE 		= "test";
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		addPreferencesFromResource(R.xml.settings);
	}
	
	/**
	 * Funci que llegeix la preferencia de velocitat.
	 * @param Context
	 * @return - String - velocitat 
	 */
	public static String getVelocity(Context context){
		return PreferenceManager.getDefaultSharedPreferences(context).getString(KEY_VEL, String.valueOf(Main.VELOCITY_FAST));
	}
	
	/**
	 * Funci que llegeix la preferencia de opacitat.
	 * @param Context
	 * @return - String - opacitat 
	 */
	public static String getOpacity(Context context){
		return PreferenceManager.getDefaultSharedPreferences(context).getString(KEY_OPA, String.valueOf(Main.OPACITY_MIDDLE));
	}
	
	/**
	 * Funci que llegeix la preferencia de tipus de test.
	 * @param Context
	 * @return - String - tipus de test.  
	 */
	public static String getType(Context context){
		return PreferenceManager.getDefaultSharedPreferences(context).getString(KEY_TYPE, String.valueOf(Main.TYPE_SMS));
	}
	
}
