package com.mist;

import java.util.ArrayList;
import java.util.Random;

import android.content.Intent;
import android.graphics.Point;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Ingenieria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunay
 * 
 * @Author UOC
 * @version Android 1.6, 2.1, 2.2
 */
public abstract class Tapjacking{

	static final String TAG = "TAPJACKING";
	
	
	public abstract Intent getIntent();
	
	public abstract int getSleep();

	
	//Punts de la pantalla on apareixeran les imatges
	protected ArrayList<Point> puntos = new ArrayList<Point>();
	//Posici actual de l'imatge
	protected int actualPos = 0;
	//Nombre de vegades que apareixer l'imatge
	private int maxPoints = 30;
	
	//Punt clau on cambiarem d'una imatge a l'altre
	private Point markPoint;
	
	//Arrays de punts aleatoris
	int[] px = {150, 200, 245, 300, 330, 50, 100, 160, 290, 210 }; 
	int[] py = {50, 130, 235, 250, 300, 350, 400, 450, 500, 100 };
	
	public void createPoints(Point specialPoint, int velocity){
		//Guardem el punt especial
		markPoint = specialPoint;
		int j =0;
		Random rnd = new Random(System.currentTimeMillis());
		while(j<maxPoints){
			//Obtenim un nombre aleatori que servir per crear un punt amb l'array px i l'array py
			int x = (int)(rnd.nextDouble() * 10.0);
			
			for(int i=0; i<(velocity+1) ; i++){
				puntos.add(new Point(px[x], py[x]));
				Log.d(TAG, "New random point at "+ px[x]+ ","+py[x]);
			}

			//A l'iteraci 10 i 20, cambiem l'imatge de la poma per la del androide
			if(j==10 || j ==20){
				for(int i=0; i<=2; i++){
					puntos.add(specialPoint);
				}
			}
			j++;
		}
	}
	
	//
	public Point getFirst(){
		if(!this.puntos.isEmpty()){
			actualPos++;
			return this.puntos.get(0);
		}
		return new Point(0, 0);
	}
	/**
	 * @return el nombre de moviments
	 */
	public int getNumMoves(){ return this.puntos.size(); }

	/**
	 * Funci que serveix per moure l'imatge, seleccionant un nou punt de l'array
	 * @param component que mourem
	 * @return boolean 
	 */
	public boolean move(View vista){
		if( vista.getId() == R.id.apple ){
			if(actualPos>0 && actualPos<this.puntos.size()){
				Point p = this.puntos.get(actualPos++);
				if (p.x == markPoint.x && p.y == markPoint.y){
					((ImageView)vista).setImageResource(R.drawable.android);
					
				}else{
					((ImageView)vista).setImageResource(R.drawable.apple);
				}
				vista.setPadding(p.x, p.y, 0, 0);
			}else{
				View v = vista.getRootView().findViewById(R.id.fin);
				v.setVisibility(View.VISIBLE);
			}
			return true;
		}
		return false;
	}

}

