package com.mist;
//Imports
import com.mist.database.FilterSQL;
import com.mist.filter.FilterCall;
import com.mist.filter.FilterSMS;
import com.mist.utils.Constants;
import android.app.Activity;
import android.os.Bundle;
import android.text.Editable;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Enginyeria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunya
 * 
 * @Author Alejandro Garca Rodrguez
 * @version Android 1.6, 2.1, 2.2
 * 
 * @description Activitat que gestiona la pantalla d'afegir nous filtres
 */
public class AddFilterTab extends Activity{

	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.add_filters);
    }
    
    public void addSMSFilter(View v) {
  		try {
			FilterSQL sql = new FilterSQL(getApplicationContext());
			
			EditText view = (EditText)findViewById(R.id.smsnum);
			Editable text = view.getText();
			
			if( (sql.insertFilter(Integer.parseInt(text.toString()), FilterSMS.FILTER_TYPE)) > 0){
				sendResult(true);
			}else{
				sendResult(false);
			}
		} catch (NumberFormatException e) {
			Log.w(Constants.TAG, getResources().getString(R.string.filter_add_fail));
			sendResult(false);
		}
  	}
    
    public void addTelfFilter(View v) {
    	try {
			FilterSQL sql = new FilterSQL(getApplicationContext());
			
			EditText view = (EditText)findViewById(R.id.telfnum);
			Editable text = view.getText();
			
			if( (sql.insertFilter(Integer.parseInt(text.toString()), FilterCall.FILTER_TYPE)) > 0){
				sendResult(true);
			}else{
				sendResult(false);
			}
		} catch (NumberFormatException e) {
			Log.w(Constants.TAG, getResources().getString(R.string.filter_add_fail));
			sendResult(false);
		}
  	}
    
    
    private void sendResult(boolean value){
    	((EditText)findViewById(R.id.telfnum)).setText("");
    	((EditText)findViewById(R.id.smsnum)).setText("");
    	
    	if(value){
    		Toast.makeText(getApplicationContext(), R.string.filter_add_ok, Toast.LENGTH_LONG).show();
    	}else{
    		Toast.makeText(getApplicationContext(), R.string.filter_add_fail, Toast.LENGTH_LONG).show();
    	}
    }
    
}
