package com.mist;
//Imports
import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import com.mist.filter.Filter;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Enginyeria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunya
 * 
 * @Author Alejandro Garca Rodrguez
 * @version Android 1.6, 2.1, 2.2
 * 
 * @description Aquesta es l'activitat que es troba en mode "escolta" per detectar els intents que volem
 * 				filtrar. Per aix, es defineixen els <intent - filter> adequats.
 */
public class FilterListener extends Activity{
	
	
	/** Called when the activity is first created. */
    @Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.filter_block);
        
        Filter filter = new Filter();
        filter = filter.getCorrectFilter(getApplicationContext(), getIntent());
        
       
        //Si existeix el filtre, enviem la notificaci
        if(filter.filter( getIntent() ) ){
        	String ns = Context.NOTIFICATION_SERVICE;
            NotificationManager mNotificationManager = (NotificationManager)getSystemService(ns);
            
            int icon = R.drawable.mist_icon_bar;
            CharSequence text = getResources().getString(R.string.alert_status);
            long when = System.currentTimeMillis();
            
            Notification notification = new Notification(icon, text, when);
            notification.defaults |= Notification.DEFAULT_SOUND;
            
            Context context = getApplicationContext();
            CharSequence contentTitle = getResources().getString(R.string.app_name);
            CharSequence contentText = getResources().getString(R.string.alert_message);
            Intent notificationIntent = new Intent(this, ListBlocked.class);
            PendingIntent contentIntent = PendingIntent.getActivity(this, 0, notificationIntent, 0);

            notification.setLatestEventInfo(context, contentTitle, contentText, contentIntent);
            
            mNotificationManager.notify(1, notification);
        }
        
        try {
			Thread.sleep(2000);
			this.setVisible(false);
			finish();
		} catch (InterruptedException e) {
			
			e.printStackTrace();
		}   
    }
}
