package com.mist;
//Imports
import android.app.ListActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import com.mist.database.FilterSQL;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Enginyeria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunya
 * 
 * @Author Alejandro Garca Rodrguez
 * @version Android 1.6, 2.1, 2.2
 * 
 * @description Activitat  que mostra el llistat d'accions realitzades per l'aplicaci
 * 				Hereta de {@link}ListActivity per facilitat alhora de mostrar les dades de forma automtica 
 */
public class ListBlocked extends ListActivity{

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		//Pintem la llista
		paintList();
	}

		
	private void paintList(){
		FilterSQL sql = new FilterSQL(getApplicationContext());
		
		//Recuperem les accions fins ara de la base de dades
		String[] values = sql.getActions();
		
		setListAdapter(new ArrayAdapter<String>(getApplicationContext(), R.layout.block_list, values));

		ListView lv = getListView();
		lv.setTextFilterEnabled(true);
	}
	
	private void refresh(){
		//Tornem a re-pintar la llista
		paintList();
	}

	//Genera el men
	@Override
	public boolean onCreateOptionsMenu(Menu menu){
		super.onCreateOptionsMenu(menu);
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu_list, menu);
		return true;
	}

	/**
	 * Funci que captura l'item seleccionat del menu 
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item){
		switch(item.getItemId()){
		case R.id.refresh:
			refresh();
			return true;
		case R.id.drop:
			FilterSQL sql = new FilterSQL(getApplicationContext());
			sql.deleteTableActions();
			
			//Refresquem el llistat
			refresh();
			return true;
		}
		return false;
	}

}
