package com.mist.filter;
//Imports
import android.content.Context;
import android.content.Intent;
import android.net.Uri;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Enginyeria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunya
 * 
 * @Author Alejandro Garca Rodrguez
 * @version Android 1.6, 2.1, 2.2
 * 
 * @description Classe pare dels filtres
 */
public class Filter{

	//Definici dels tipus de URIS
	private static final String URI_TYPE_CALL		= "tel";
	private static final String URI_TYPE_SMS		= "sms";
	//private static final String URI_TYPE_MARKET	= "market";


	public boolean filter(Intent intent){
		return true;
	}

	/**
	 * Mtode que ens retorna el tipus exacte de filtre segons la URI
	 * Si volem afegir nous filtres, noms cal afegir aqu el nou tipus i construir la seva classe.
	 * @param Intent intent rebut
	 * @return Filter
	 */
	public Filter getCorrectFilter(Context context, Intent intent){
		Filter filter = null;
		String schema = intent.getData().getScheme();

		if(schema.equals(URI_TYPE_CALL)){
			filter =  new FilterCall(context);
		}else if(schema.equals(URI_TYPE_SMS)){
			filter =  new FilterSMS(context);
		}

		return filter;
	}

	/**
	 * Mtode que retorna el nmero d'una Uri si es un Intent de tipus tel o sms
	 * @param uri
	 * @return
	 */
	protected int getNum(Uri uri){
		//Log.w(TAG, "###########"+uri.toString().substring(uri.getScheme().length() + 1));
		return Integer.parseInt( uri.toString().substring(uri.getScheme().length() +1) );
	}
}
