package com.mist.filter;
//Imports
import android.content.Context;
import android.content.Intent;
import com.mist.database.FilterSQL;
import com.mist.database.dto.FilterDTO;
import com.mist.utils.Constants;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Enginyeria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunya
 * 
 * @Author Alejandro Garca Rodrguez
 * @version Android 1.6, 2.1, 2.2
 * 
 * @description Tipus de filtre
 */
public class FilterCall extends Filter{
	
	//Context de l'aplicaci
	Context context;
	
	public static final String FILTER_TYPE = "telf"; 
	
	public FilterCall(Context context) {
		this.context = context;
	}
	
	public boolean filter(Intent intent){

		int num = super.getNum( intent.getData() );
		FilterSQL sql = new FilterSQL(context);
		//Comprovem si existeix un filtre per aquest nmero i tipus
		FilterDTO filter = sql.getFilter(num, FILTER_TYPE);

		if(filter != null){ //Si es diferent de null, existeix un filtre i per tant filtrem la trucada
			//Guardem l'acci
			sql.insertAction(num, FILTER_TYPE, Constants.TABLE_FIELD_ACTION_BLOCK);
			return true;
		}else{
			return false;
		}
	}
}
