package com.mist.utils;

import com.mist.R;
import com.mist.R.xml;

import android.content.Context;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;

/**
 * Projecte MIST
 * 
 * Treball de final de carrera. Enginyeria Tcnica en Informtica de Sistemes
 * Universitat Oberta de Catalunay
 * 
 * @Author UOC
 * @version Android 1.6, 2.1, 2.2
 */
public class Prefs extends PreferenceActivity {
	
	private static final String KEY_DEFAULT 		= "default";
	private static final String KEY_FILTER 			= "filter";
	
	private static final boolean VALUE_DEFAULT		= true;
	
	static final int TYPE_SMS = 0;
	static final int TYPE_CALL = 1;
	static final int TYPE_ALL = 2;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		addPreferencesFromResource(R.xml.settings);
	}
	
		
	/**
	 * Funci que llegeix la preferencia de filtres per defecte.
	 * @param Context
	 * @return - boolean - default 
	 */
	public static boolean getIsDefault(Context context){
		return PreferenceManager.getDefaultSharedPreferences(context).getBoolean(KEY_DEFAULT, VALUE_DEFAULT);
	}
	
	/**
	 * Funci que llegeix la preferencia de tipus de test.
	 * @param Context
	 * @return - String - tipus de test.  
	 */
	public static String getType(Context context){
		return PreferenceManager.getDefaultSharedPreferences(context).getString(KEY_FILTER, String.valueOf(TYPE_ALL));
	}
	
}
